(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     49423,       1465]
NotebookOptionsPosition[     46131,       1344]
NotebookOutlinePosition[     46629,       1363]
CellTagsIndexPosition[     46586,       1360]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<SpinDynamica`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.450336910857295*^9, 3.450336917940371*^9}, {
  3.502947908875107*^9, 3.502947910312932*^9}, {3.5689027255922747`*^9, 
  3.5689027260212994`*^9}}],

Cell[BoxData[
 TagBox[
  FrameBox["\<\"SpinDynamica version 3.0.1 loaded\"\>"],
  DisplayForm]], "Print",
 CellChangeTimes->{3.7121605269777555`*^9}],

Cell[BoxData[
 TemplateBox[{
  "ModifyBuiltIn","report",
   "\"The following built-in routines have been modified in SpinDynamica: \\!\
\\(\\*RowBox[{\\\"{\\\", RowBox[{\\\"Chop\\\", \\\",\\\", \\\"Dot\\\", \
\\\",\\\", \\\"Duration\\\", \\\",\\\", \\\"Exp\\\", \\\",\\\", \
\\\"Expand\\\", \\\",\\\", \\\"ExpandAll\\\", \\\",\\\", \\\"NumericQ\\\", \\\
\",\\\", \\\"Plus\\\", \\\",\\\", \\\"Power\\\", \\\",\\\", \\\"Simplify\\\", \
\\\",\\\", \\\"Times\\\", \\\",\\\", \\\"WignerD\\\"}], \\\"}\\\"}]\\). \
\\nEvaluate \
??\\!\\(\\*\\nStyleBox[\\\"symbol\\\",\\nFontSlant->\\\"Italic\\\"]\\) to \
generate the additional definitions for \
\\!\\(\\*\\nStyleBox[\\\"symbol\\\",\\nFontSlant->\\\"Italic\\\"]\\).\"",2,1,
   1,29119468201827309624,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.7121605281250715`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetSpinSystem", "[", "2", "]"}]], "Input",
 CellChangeTimes->{{3.45616396286911*^9, 3.45616396576895*^9}, 
   3.456201606022471*^9, 3.456204541615698*^9, 3.456204576928049*^9}],

Cell[BoxData[
 TemplateBox[{
  "SetSpinSystem","set",
   "\"the spin system has been set to \\!\\(\\*RowBox[{\\\"{\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \\\",\\\", \
FractionBox[\\\"1\\\", \\\"2\\\"]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"2\\\", \\\",\\\", FractionBox[\\\"1\\\", \\\"2\
\\\"]}], \\\"}\\\"}]}], \\\"}\\\"}]\\)\"",2,2,2,29119468201827309624,"Local"},
  
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.456163966369556*^9, {3.456164286553218*^9, 3.45616430554272*^9}, 
   3.456164374062786*^9, 3.456164593915292*^9, 3.4562015544899282`*^9, 
   3.456201608205554*^9, 3.4562021802379427`*^9, 3.456202498330545*^9, 
   3.4562028142931004`*^9, 3.456203069214973*^9, 3.456204078992474*^9, 
   3.456204140752467*^9, 3.456204494804265*^9, 3.4562045420959673`*^9, {
   3.456204577367599*^9, 3.456204583615263*^9}, 3.456204854481304*^9, 
   3.45620489799152*^9, 3.461036948022011*^9, 3.461066145853022*^9, 
   3.502942771367139*^9, {3.502943046043352*^9, 3.5029430543488607`*^9}, 
   3.50294359940742*^9, 3.5029441497184153`*^9, 3.502944538756997*^9, 
   3.502947914744649*^9, 3.502949484577181*^9, 3.515084043748011*^9, 
   3.5689027304495525`*^9, 3.7121605283100834`*^9}],

Cell[BoxData[
 TemplateBox[{
  "SetBasis","set",
   "\"the state basis has been set to \\!\\(\\*RowBox[{\\\"ZeemanBasis\\\", \
\\\"[\\\", RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"{\\\", \
RowBox[{\\\"1\\\", \\\",\\\", FractionBox[\\\"1\\\", \\\"2\\\"]}], \
\\\"}\\\"}], \\\",\\\", RowBox[{\\\"{\\\", RowBox[{\\\"2\\\", \\\",\\\", \
FractionBox[\\\"1\\\", \\\"2\\\"]}], \\\"}\\\"}]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"BasisLabels\\\", \\\"\[Rule]\\\", \\\"Automatic\\\"}]}], \
\\\"]\\\"}]\\).\"",2,2,3,29119468201827309624,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.456163966369556*^9, {3.456164286553218*^9, 3.45616430554272*^9}, 
   3.456164374062786*^9, 3.456164593915292*^9, 3.4562015544899282`*^9, 
   3.456201608205554*^9, 3.4562021802379427`*^9, 3.456202498330545*^9, 
   3.4562028142931004`*^9, 3.456203069214973*^9, 3.456204078992474*^9, 
   3.456204140752467*^9, 3.456204494804265*^9, 3.4562045420959673`*^9, {
   3.456204577367599*^9, 3.456204583615263*^9}, 3.456204854481304*^9, 
   3.45620489799152*^9, 3.461036948022011*^9, 3.461066145853022*^9, 
   3.502942771367139*^9, {3.502943046043352*^9, 3.5029430543488607`*^9}, 
   3.50294359940742*^9, 3.5029441497184153`*^9, 3.502944538756997*^9, 
   3.502947914744649*^9, 3.502949484577181*^9, 3.515084043748011*^9, 
   3.5689027304495525`*^9, 3.712160528343605*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["default operator basis (ZeemanKetBraOperatorBasis)", "Section",
 CellChangeTimes->{{3.50294382080295*^9, 3.5029438214739943`*^9}, {
  3.502947922240296*^9, 3.5029479319853897`*^9}}],

Cell[CellGroupData[{

Cell["natural sorting order", "Subsection",
 CellChangeTimes->{{3.502947974319755*^9, 3.502947977358139*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetOperatorBasis", "[", "]"}]], "Input",
 CellChangeTimes->{{3.5029479382894087`*^9, 3.502947941816135*^9}}],

Cell[BoxData[
 TemplateBox[{
  "SetOperatorBasis","set",
   "\"the operator basis has been set to \
\\!\\(\\*RowBox[{\\\"ShiftAndZOperatorBasis\\\", \\\"[\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \
\\\",\\\", FractionBox[\\\"1\\\", \\\"2\\\"]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"2\\\", \\\",\\\", FractionBox[\\\"1\\\", \\\"2\
\\\"]}], \\\"}\\\"}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"Sorted\\\", \\\"\
\[Rule]\\\", \\\"CoherenceOrder\\\"}]}], \\\"]\\\"}]\\).\"",2,3,4,
   29119468201827309624,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{3.502947942355506*^9, 3.502948023713407*^9, 
  3.5029494953188057`*^9, 3.5150840438295918`*^9, 3.5689027308035727`*^9, 
  3.7121605287138467`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BasisOperators", "[", "]"}]], "Input",
 CellChangeTimes->{{3.502947951639186*^9, 3.5029479541835814`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{
     TagBox[
      SubsuperscriptBox["I", "1", "-"],
      DisplayForm], 
     AdjustmentBox["\[Bullet]",
      BoxMargins->{{-0.3, 0}, {0, 0}}], 
     TagBox[
      SubsuperscriptBox["I", "2", "-"],
      DisplayForm]}],
    DisplayForm], ",", 
   RowBox[{
    SqrtBox["2"], " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubsuperscriptBox["I", "1", "-"],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "z"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{
    SqrtBox["2"], " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "z"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubsuperscriptBox["I", "2", "-"],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   FractionBox[
    TagBox[
     SubsuperscriptBox["I", "1", "-"],
     DisplayForm], 
    SqrtBox["2"]], ",", 
   FractionBox[
    TagBox[
     SubsuperscriptBox["I", "2", "-"],
     DisplayForm], 
    SqrtBox["2"]], ",", 
   TagBox[
    RowBox[{
     TagBox[
      SubsuperscriptBox["I", "1", "-"],
      DisplayForm], 
     AdjustmentBox["\[Bullet]",
      BoxMargins->{{-0.3, 0}, {0, 0}}], 
     TagBox[
      SubsuperscriptBox["I", "2", "+"],
      DisplayForm]}],
    DisplayForm], ",", 
   TagBox[
    RowBox[{
     TagBox[
      SubsuperscriptBox["I", "1", "+"],
      DisplayForm], 
     AdjustmentBox["\[Bullet]",
      BoxMargins->{{-0.3, 0}, {0, 0}}], 
     TagBox[
      SubsuperscriptBox["I", "2", "-"],
      DisplayForm]}],
    DisplayForm], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "z"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "z"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"1", "z"}]],
    DisplayForm], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"2", "z"}]],
    DisplayForm], ",", 
   FractionBox["\<\"\[DoubleStruckOne]\"\>", "2"], ",", 
   RowBox[{
    SqrtBox["2"], " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubsuperscriptBox["I", "1", "+"],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "z"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{
    SqrtBox["2"], " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "z"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubsuperscriptBox["I", "2", "+"],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   FractionBox[
    TagBox[
     SubsuperscriptBox["I", "1", "+"],
     DisplayForm], 
    SqrtBox["2"]], ",", 
   FractionBox[
    TagBox[
     SubsuperscriptBox["I", "2", "+"],
     DisplayForm], 
    SqrtBox["2"]], ",", 
   TagBox[
    RowBox[{
     TagBox[
      SubsuperscriptBox["I", "1", "+"],
      DisplayForm], 
     AdjustmentBox["\[Bullet]",
      BoxMargins->{{-0.3, 0}, {0, 0}}], 
     TagBox[
      SubsuperscriptBox["I", "2", "+"],
      DisplayForm]}],
    DisplayForm]}], "}"}]], "Output",
 CellChangeTimes->{3.5029479546888647`*^9, 3.50294802377915*^9, 
  3.502949495452547*^9, 3.5150840438624687`*^9, 3.5689027311415925`*^9, 
  3.7121605287940435`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CoherenceOrder", "/@", 
  RowBox[{"BasisOperators", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.50294801405226*^9, 3.502948019583128*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{{3.502948020211547*^9, 3.502948023814*^9}, 
   3.502949495517769*^9, 3.5150840439169073`*^9, 3.5689027312926006`*^9, 
   3.712160528839076*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["sort the basis operators according to the coherence order", "Subsection",
 CellChangeTimes->{{3.502947974319755*^9, 3.5029479868061333`*^9}, {
  3.502948084952468*^9, 3.502948090510055*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetOperatorBasis", "[", 
  RowBox[{"ZeemanKetBraOperatorBasis", "[", 
   RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5029479382894087`*^9, 3.502947941816135*^9}, {
  3.502947991256049*^9, 3.502948001775217*^9}}],

Cell[BoxData[
 TemplateBox[{
  "SetOperatorBasis","set",
   "\"the operator basis has been set to \
\\!\\(\\*RowBox[{\\\"ZeemanKetBraOperatorBasis\\\", \\\"[\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \
\\\",\\\", FractionBox[\\\"1\\\", \\\"2\\\"]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"2\\\", \\\",\\\", FractionBox[\\\"1\\\", \\\"2\
\\\"]}], \\\"}\\\"}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"Sorted\\\", \\\"\
\[Rule]\\\", \\\"CoherenceOrder\\\"}]}], \\\"]\\\"}]\\).\"",2,6,5,
   29119468201827309624,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.502947942355506*^9, {3.502948002566856*^9, 3.502948030945168*^9}, 
   3.502949495574297*^9, 3.515084043967639*^9, 3.5689027316816235`*^9, 
   3.712160528938542*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BasisOperators", "[", "]"}]], "Input",
 CellChangeTimes->{{3.502947951639186*^9, 3.5029479541835814`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"\<\"\[LeftBracketingBar]\[Beta]\[Beta]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Alpha]\[Alpha]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Beta]\[Beta]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Beta]\[Alpha]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Beta]\[Beta]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Alpha]\[Beta]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Beta]\[Alpha]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Alpha]\[Alpha]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Alpha]\[Beta]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Alpha]\[Alpha]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Beta]\[Beta]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Beta]\[Beta]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Beta]\[Alpha]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Beta]\[Alpha]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Beta]\[Alpha]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Alpha]\[Beta]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Alpha]\[Beta]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Beta]\[Alpha]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Alpha]\[Beta]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Alpha]\[Beta]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Alpha]\[Alpha]\[RightAngleBracket]\"\>",
     ".", "\<\"<\[Alpha]\[Alpha]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Beta]\[Alpha]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Beta]\[Beta]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Alpha]\[Beta]\[RightAngleBracket]\"\>", 
    ".", "\<\"<\[Beta]\[Beta]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Alpha]\[Alpha]\[RightAngleBracket]\"\>",
     ".", "\<\"<\[Beta]\[Alpha]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Alpha]\[Alpha]\[RightAngleBracket]\"\>",
     ".", "\<\"<\[Alpha]\[Beta]|\"\>"}], ",", 
   RowBox[{"\<\"\[LeftBracketingBar]\[Alpha]\[Alpha]\[RightAngleBracket]\"\>",
     ".", "\<\"<\[Beta]\[Beta]|\"\>"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5029479546888647`*^9, {3.5029480053864*^9, 3.5029480311081038`*^9}, 
   3.502949495708009*^9, 3.515084044079077*^9, 3.568902731904636*^9, 
   3.7121605289565554`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CoherenceOrder", "/@", 
  RowBox[{"BasisOperators", "[", "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{3.502948031222661*^9, 3.502949495840767*^9, 
  3.51508404421063*^9, 3.5689027320646453`*^9, 3.7121605290292597`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{"Sorted", "\[Rule]", "False"}], "]"}]}], "\[IndentingNewLine]", 
   "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.502948057042334*^9, 3.502948077343223*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "1", "0"},
     {"0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "1"},
     {"0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", 
      "0", "0"},
     {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "1", "0", "0", 
      "0", "0"},
     {"0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   SparseArray[
    Automatic, {16, 16}, 0, {
     1, {{0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16}, {{13}, {
       14}, {15}, {5}, {9}, {16}, {6}, {7}, {10}, {11}, {1}, {8}, {12}, {2}, {
       3}, {4}}}, {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 
      1}}]]]]], "Output",
 CellChangeTimes->{{3.5029480719639378`*^9, 3.502948077888792*^9}, 
   3.502949496390864*^9, 3.515084044410375*^9, 3.5689027321416492`*^9, 
   3.7121605290447903`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["CartesianProductOperatorBasis", "Section",
 CellChangeTimes->{{3.50294382080295*^9, 3.5029438214739943`*^9}, {
  3.502947922240296*^9, 3.5029479319853897`*^9}, {3.502948107303679*^9, 
  3.502948116013966*^9}}],

Cell[CellGroupData[{

Cell["default sorting", "Subsection",
 CellChangeTimes->{{3.502947974319755*^9, 3.502947977358139*^9}, {
  3.502948128357976*^9, 3.502948137661641*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetOperatorBasis", "[", 
  RowBox[{"CartesianProductOperatorBasis", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5029479382894087`*^9, 3.502947941816135*^9}, {
  3.502948120242498*^9, 3.5029481212295837`*^9}}],

Cell[BoxData[
 TemplateBox[{
  "SetOperatorBasis","set",
   "\"the operator basis has been set to \
\\!\\(\\*RowBox[{\\\"CartesianProductOperatorBasis\\\", \\\"[\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \
\\\",\\\", FractionBox[\\\"1\\\", \\\"2\\\"]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"2\\\", \\\",\\\", FractionBox[\\\"1\\\", \\\"2\
\\\"]}], \\\"}\\\"}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"Sorted\\\", \\\"\
\[Rule]\\\", \\\"SpinProductRank\\\"}]}], \\\"]\\\"}]\\).\"",2,10,6,
   29119468201827309624,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.502947942355506*^9, 3.502948023713407*^9, {3.502948122221609*^9, 
   3.502948139966732*^9}, 3.502949501028474*^9, 3.515084044464059*^9, 
   3.568902732407665*^9, 3.712160529237884*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BasisOperators", "[", "]"}]], "Input",
 CellChangeTimes->{{3.502947951639186*^9, 3.5029479541835814`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["\<\"\[DoubleStruckOne]\"\>", "2"], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"1", "x"}]],
    DisplayForm], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"1", "y"}]],
    DisplayForm], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"1", "z"}]],
    DisplayForm], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"2", "x"}]],
    DisplayForm], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"2", "y"}]],
    DisplayForm], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"2", "z"}]],
    DisplayForm], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "x"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "x"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "x"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "y"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "x"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "z"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "y"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "x"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "y"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "y"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "y"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "z"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "z"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "x"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "z"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "y"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "z"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "z"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.5029479546888647`*^9, 3.50294802377915*^9, 
  3.502948142229126*^9, 3.502949501111565*^9, 3.5150840445143127`*^9, 
  3.5689027324896693`*^9, 3.7121605293498836`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CoherenceOrder", "/@", 
  RowBox[{"BasisOperators", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.50294801405226*^9, 3.502948019583128*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", "0", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", "0", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", "0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", "0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", "0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2"}], ",", "0", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.502948020211547*^9, 3.502948023814*^9}, 
   3.502948152380042*^9, 3.5029495011446257`*^9, 3.515084044574346*^9, 
   3.5689027325906754`*^9, 3.7121605294113894`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SpinProductRank", "/@", 
  RowBox[{"BasisOperators", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.50294801405226*^9, 3.502948019583128*^9}, {
  3.502948159648831*^9, 3.5029481623908463`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2", 
   ",", "2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "2", ",", 
   "2"}], "}"}]], "Output",
 CellChangeTimes->{{3.502948020211547*^9, 3.502948023814*^9}, {
   3.502948152380042*^9, 3.5029481630846786`*^9}, 3.502949501198449*^9, 
   3.5150840446158323`*^9, 3.568902732635678*^9, 3.712160529426921*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["basis transformation matrix", "Subsection",
 CellChangeTimes->{{3.502947974319755*^9, 3.5029479868061333`*^9}, {
  3.502948084952468*^9, 3.502948090510055*^9}, {3.502948179103138*^9, 
  3.502948182701757*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ZeemanKetBraOperatorBasis", "[", 
     RowBox[{"Sorted", "\[Rule]", "CoherenceOrder"}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"CartesianProductOperatorBasis", "[", "]"}]}], 
   "\[IndentingNewLine]", "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.502948057042334*^9, 3.502948077343223*^9}, 
   3.502948194145743*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", 
      FractionBox["\[ImaginaryI]", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0"},
     {"0", "0", "0", "0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0"},
     {"0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", 
      FractionBox["\[ImaginaryI]", "2"], "0", "0", "0"},
     {"0", "0", "0", "0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0"},
     {
      FractionBox["1", "2"], "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]},
     {
      FractionBox["1", "2"], "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {"0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", 
      FractionBox["\[ImaginaryI]", "2"], 
      FractionBox["1", "2"], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0", "0"},
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"], "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}]},
     {
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"], "0", "0", 
      FractionBox["1", "2"], "0", "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"]},
     {"0", "0", "0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], 
      FractionBox["\[ImaginaryI]", "2"], "0"},
     {"0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", "0", "0", "0", "0", "0", 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", 
      FractionBox["\[ImaginaryI]", "2"], "0", "0", "0"},
     {"0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], "0", "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", "0", "0"},
     {"0", "0", "0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   SparseArray[
    Automatic, {16, 16}, 0, {
     1, {{0, 4, 8, 12, 16, 20, 24, 28, 32, 36, 40, 44, 48, 52, 56, 60, 64}, {{
       8}, {9}, {11}, {12}, {5}, {6}, {14}, {15}, {2}, {3}, {10}, {13}, {2}, {
       3}, {10}, {13}, {5}, {6}, {14}, {15}, {1}, {4}, {7}, {16}, {1}, {4}, {
       7}, {16}, {8}, {9}, {11}, {12}, {8}, {9}, {11}, {12}, {1}, {4}, {7}, {
       16}, {1}, {4}, {7}, {16}, {5}, {6}, {14}, {15}, {2}, {3}, {10}, {13}, {
       2}, {3}, {10}, {13}, {5}, {6}, {14}, {15}, {8}, {9}, {11}, {12}}}, {
      Rational[1, 2], Complex[0, Rational[1, 2]], Complex[0, Rational[1, 2]], 
       Rational[-1, 2], Rational[1, 2], Complex[0, Rational[1, 2]], 
       Rational[-1, 2], Complex[0, Rational[-1, 2]], Rational[1, 2], Complex[
       0, Rational[1, 2]], Rational[-1, 2], Complex[0, Rational[-1, 2]], 
       Rational[1, 2], Complex[0, Rational[1, 2]], Rational[1, 2], Complex[
       0, Rational[1, 2]], Rational[1, 2], Complex[0, Rational[1, 2]], 
       Rational[1, 2], Complex[0, Rational[1, 2]], Rational[1, 2], 
       Rational[-1, 2], Rational[-1, 2], Rational[1, 2], Rational[1, 2], 
       Rational[-1, 2], Rational[1, 2], Rational[-1, 2], Rational[1, 2], 
       Complex[0, Rational[-1, 2]], Complex[0, Rational[1, 2]], Rational[
       1, 2], Rational[1, 2], Complex[0, Rational[1, 2]], Complex[
       0, Rational[-1, 2]], Rational[1, 2], Rational[1, 2], Rational[1, 2], 
       Rational[-1, 2], Rational[-1, 2], Rational[1, 2], Rational[1, 2], 
       Rational[1, 2], Rational[1, 2], Rational[1, 2], Complex[
       0, Rational[-1, 2]], Rational[-1, 2], Complex[0, Rational[1, 2]], 
       Rational[1, 2], Complex[0, Rational[-1, 2]], Rational[-1, 2], Complex[
       0, Rational[1, 2]], Rational[1, 2], Complex[0, Rational[-1, 2]], 
       Rational[1, 2], Complex[0, Rational[-1, 2]], Rational[1, 2], Complex[
       0, Rational[-1, 2]], Rational[1, 2], Complex[0, Rational[-1, 2]], 
       Rational[1, 2], Complex[0, Rational[-1, 2]], Complex[
       0, Rational[-1, 2]], Rational[-1, 2]}}]]]]], "Output",
 CellChangeTimes->{{3.5029480719639378`*^9, 3.502948077888792*^9}, 
   3.5029481952152*^9, 3.502949501346863*^9, 3.5150840447343817`*^9, 
   3.568902732872691*^9, 3.712160529479438*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["ShiftAndZOperatorBasis", "Section",
 CellChangeTimes->{{3.50294382080295*^9, 3.5029438214739943`*^9}, {
  3.502947922240296*^9, 3.5029479319853897`*^9}, {3.502948107303679*^9, 
  3.502948116013966*^9}, {3.502948222983131*^9, 3.502948225941605*^9}}],

Cell[CellGroupData[{

Cell["default sorting", "Subsection",
 CellChangeTimes->{{3.502947974319755*^9, 3.502947977358139*^9}, {
  3.502948128357976*^9, 3.502948137661641*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetOperatorBasis", "[", 
  RowBox[{"ShiftAndZOperatorBasis", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5029479382894087`*^9, 3.502947941816135*^9}, {
   3.502948120242498*^9, 3.5029481212295837`*^9}, 3.50294822997069*^9}],

Cell[BoxData[
 TemplateBox[{
  "SetOperatorBasis","set",
   "\"the operator basis has been set to \
\\!\\(\\*RowBox[{\\\"ShiftAndZOperatorBasis\\\", \\\"[\\\", \
RowBox[{RowBox[{\\\"{\\\", RowBox[{RowBox[{\\\"{\\\", RowBox[{\\\"1\\\", \
\\\",\\\", FractionBox[\\\"1\\\", \\\"2\\\"]}], \\\"}\\\"}], \\\",\\\", \
RowBox[{\\\"{\\\", RowBox[{\\\"2\\\", \\\",\\\", FractionBox[\\\"1\\\", \\\"2\
\\\"]}], \\\"}\\\"}]}], \\\"}\\\"}], \\\",\\\", RowBox[{\\\"Sorted\\\", \\\"\
\[Rule]\\\", \\\"CoherenceOrder\\\"}]}], \\\"]\\\"}]\\).\"",2,15,7,
   29119468201827309624,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{
  3.502947942355506*^9, 3.502948023713407*^9, {3.502948122221609*^9, 
   3.502948139966732*^9}, 3.502948232146802*^9, 3.502949557696991*^9, 
   3.515084044846887*^9, 3.5689027331157055`*^9, 3.7121605294939485`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BasisOperators", "[", "]"}]], "Input",
 CellChangeTimes->{{3.502947951639186*^9, 3.5029479541835814`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   TagBox[
    RowBox[{
     TagBox[
      SubsuperscriptBox["I", "1", "-"],
      DisplayForm], 
     AdjustmentBox["\[Bullet]",
      BoxMargins->{{-0.3, 0}, {0, 0}}], 
     TagBox[
      SubsuperscriptBox["I", "2", "-"],
      DisplayForm]}],
    DisplayForm], ",", 
   RowBox[{
    SqrtBox["2"], " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubsuperscriptBox["I", "1", "-"],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "z"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{
    SqrtBox["2"], " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "z"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubsuperscriptBox["I", "2", "-"],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   FractionBox[
    TagBox[
     SubsuperscriptBox["I", "1", "-"],
     DisplayForm], 
    SqrtBox["2"]], ",", 
   FractionBox[
    TagBox[
     SubsuperscriptBox["I", "2", "-"],
     DisplayForm], 
    SqrtBox["2"]], ",", 
   TagBox[
    RowBox[{
     TagBox[
      SubsuperscriptBox["I", "1", "-"],
      DisplayForm], 
     AdjustmentBox["\[Bullet]",
      BoxMargins->{{-0.3, 0}, {0, 0}}], 
     TagBox[
      SubsuperscriptBox["I", "2", "+"],
      DisplayForm]}],
    DisplayForm], ",", 
   TagBox[
    RowBox[{
     TagBox[
      SubsuperscriptBox["I", "1", "+"],
      DisplayForm], 
     AdjustmentBox["\[Bullet]",
      BoxMargins->{{-0.3, 0}, {0, 0}}], 
     TagBox[
      SubsuperscriptBox["I", "2", "-"],
      DisplayForm]}],
    DisplayForm], ",", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "z"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "z"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"1", "z"}]],
    DisplayForm], ",", 
   TagBox[
    SubscriptBox["I", 
     RowBox[{"2", "z"}]],
    DisplayForm], ",", 
   FractionBox["\<\"\[DoubleStruckOne]\"\>", "2"], ",", 
   RowBox[{
    SqrtBox["2"], " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubsuperscriptBox["I", "1", "+"],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubscriptBox["I", 
         RowBox[{"2", "z"}]],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   RowBox[{
    SqrtBox["2"], " ", 
    RowBox[{"(", 
     TagBox[
      RowBox[{
       TagBox[
        SubscriptBox["I", 
         RowBox[{"1", "z"}]],
        DisplayForm], 
       AdjustmentBox["\[Bullet]",
        BoxMargins->{{-0.3, 0}, {0, 0}}], 
       TagBox[
        SubsuperscriptBox["I", "2", "+"],
        DisplayForm]}],
      DisplayForm], ")"}]}], ",", 
   FractionBox[
    TagBox[
     SubsuperscriptBox["I", "1", "+"],
     DisplayForm], 
    SqrtBox["2"]], ",", 
   FractionBox[
    TagBox[
     SubsuperscriptBox["I", "2", "+"],
     DisplayForm], 
    SqrtBox["2"]], ",", 
   TagBox[
    RowBox[{
     TagBox[
      SubsuperscriptBox["I", "1", "+"],
      DisplayForm], 
     AdjustmentBox["\[Bullet]",
      BoxMargins->{{-0.3, 0}, {0, 0}}], 
     TagBox[
      SubsuperscriptBox["I", "2", "+"],
      DisplayForm]}],
    DisplayForm]}], "}"}]], "Output",
 CellChangeTimes->{3.5029479546888647`*^9, 3.50294802377915*^9, 
  3.502948142229126*^9, 3.5029482342219276`*^9, 3.502949558171857*^9, 
  3.515084044929957*^9, 3.568902733166708*^9, 3.7121605295294733`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CoherenceOrder", "/@", 
  RowBox[{"BasisOperators", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.50294801405226*^9, 3.502948019583128*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", "2"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", 
   RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0", ",", "0", ",", "0", ",", 
   "0", ",", "1", ",", "1", ",", "1", ",", "1", ",", "2"}], "}"}]], "Output",
 CellChangeTimes->{{3.502948020211547*^9, 3.502948023814*^9}, 
   3.502948152380042*^9, 3.502948237121954*^9, 3.502949558203405*^9, 
   3.515084044984261*^9, 3.5689027332577133`*^9, 3.712160529595026*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SpinProductRank", "/@", 
  RowBox[{"BasisOperators", "[", "]"}]}]], "Input",
 CellChangeTimes->{{3.50294801405226*^9, 3.502948019583128*^9}, {
  3.502948159648831*^9, 3.5029481623908463`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "2", ",", "2", ",", "1", ",", "1", ",", "2", ",", "2", ",", "2", 
   ",", "1", ",", "1", ",", "0", ",", "2", ",", "2", ",", "1", ",", "1", ",", 
   "2"}], "}"}]], "Output",
 CellChangeTimes->{{3.502948020211547*^9, 3.502948023814*^9}, {
   3.502948152380042*^9, 3.5029481630846786`*^9}, 3.502948242976602*^9, 
   3.502949558230812*^9, 3.5150840450505877`*^9, 3.568902733305716*^9, 
   3.712160529607529*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["basis transformation matrix", "Subsection",
 CellChangeTimes->{{3.502947974319755*^9, 3.5029479868061333`*^9}, {
  3.502948084952468*^9, 3.502948090510055*^9}, {3.502948179103138*^9, 
  3.502948182701757*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"OperatorBasisTransformationMatrix", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ShiftAndZOperatorBasis", "[", "]"}], ",", "\[IndentingNewLine]", 
    
    RowBox[{"CartesianProductOperatorBasis", "[", "]"}]}], 
   "\[IndentingNewLine]", "]"}], "//", "MatrixForm"}]], "Input",
 CellChangeTimes->{{3.502948057042334*^9, 3.502948077343223*^9}, 
   3.502948194145743*^9, 3.502948253089612*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", 
      FractionBox["\[ImaginaryI]", "2"], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", 
      FractionBox["\[ImaginaryI]", 
       SqrtBox["2"]], "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["\[ImaginaryI]", 
       SqrtBox["2"]], "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["\[ImaginaryI]", 
       SqrtBox["2"]], "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], 
      FractionBox["\[ImaginaryI]", 
       SqrtBox["2"]], "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", 
      FractionBox["\[ImaginaryI]", "2"], 
      FractionBox["1", "2"], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      FractionBox["\[ImaginaryI]", "2"], "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], 
      FractionBox["1", "2"], "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "1"},
     {"0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "1", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"1", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], "0", "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", 
        SqrtBox["2"]]}], "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", 
        SqrtBox["2"]]}], "0"},
     {"0", 
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", 
        SqrtBox["2"]]}], "0", "0", "0", "0", "0", "0", "0", "0", "0", "0", 
      "0", "0", "0"},
     {"0", "0", "0", "0", 
      FractionBox["1", 
       SqrtBox["2"]], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", 
        SqrtBox["2"]]}], "0", "0", "0", "0", "0", "0", "0", "0", "0", "0"},
     {"0", "0", "0", "0", "0", "0", "0", 
      FractionBox["1", "2"], 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], "0", 
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", "2"]}], 
      RowBox[{"-", 
       FractionBox["1", "2"]}], "0", "0", "0", "0"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[
   SparseArray[
    Automatic, {16, 16}, 0, {
     1, {{0, 4, 6, 8, 10, 12, 16, 20, 21, 22, 23, 24, 26, 28, 30, 32, 36}, {{
       8}, {9}, {11}, {12}, {10}, {13}, {14}, {15}, {2}, {3}, {5}, {6}, {8}, {
       9}, {11}, {12}, {8}, {9}, {11}, {12}, {16}, {4}, {7}, {1}, {10}, {
       13}, {14}, {15}, {2}, {3}, {5}, {6}, {8}, {9}, {11}, {12}}}, {
      Rational[1, 2], Complex[0, Rational[1, 2]], Complex[0, Rational[1, 2]], 
       Rational[-1, 2], 2^Rational[-1, 2], Complex[0, 1] 2^Rational[-1, 2], 2^
       Rational[-1, 2], Complex[0, 1] 2^Rational[-1, 2], 2^Rational[-1, 2], 
       Complex[0, 1] 2^Rational[-1, 2], 2^Rational[-1, 2], Complex[0, 1] 
       2^Rational[-1, 2], Rational[1, 2], Complex[0, Rational[-1, 2]], 
       Complex[0, Rational[1, 2]], Rational[1, 2], Rational[1, 2], Complex[
       0, Rational[1, 2]], Complex[0, Rational[-1, 2]], Rational[1, 2], 1, 1, 
       1, 1, 2^Rational[-1, 2], Complex[0, -1] 2^Rational[-1, 2], 2^
       Rational[-1, 2], Complex[0, -1] 2^Rational[-1, 2], 2^Rational[-1, 2], 
       Complex[0, -1] 2^Rational[-1, 2], 2^Rational[-1, 2], Complex[0, -1] 
       2^Rational[-1, 2], Rational[1, 2], Complex[0, Rational[-1, 2]], 
       Complex[0, Rational[-1, 2]], Rational[-1, 2]}}]]]]], "Output",
 CellChangeTimes->{{3.5029480719639378`*^9, 3.502948077888792*^9}, 
   3.5029481952152*^9, 3.5029482542959547`*^9, 3.502949558334818*^9, 
   3.515084045170247*^9, 3.5689027336217337`*^9, 3.712160529748149*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1350, 633},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
PrintingCopies->1,
PrintingPageRange->{1, Automatic},
PrivateNotebookOptions->{"VersionedStylesheet"->{"Default.nb"[8.] -> False}},
ShowSelection->True,
FrontEndVersion->"11.0 for Microsoft Windows (64-bit) (July 28, 2016)",
StyleDefinitions->"mhl-default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 246, 4, 30, "Input"],
Cell[816, 28, 149, 4, 36, "Print"],
Cell[968, 34, 838, 15, 40, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1843, 54, 200, 3, 30, "Input"],
Cell[2046, 59, 1231, 21, 47, "Message"],
Cell[3280, 82, 1367, 22, 47, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4684, 109, 187, 2, 63, "Section"],
Cell[CellGroupData[{
Cell[4896, 115, 109, 1, 43, "Subsection"],
Cell[CellGroupData[{
Cell[5030, 120, 132, 2, 30, "Input"],
Cell[5165, 124, 775, 14, 47, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5977, 143, 130, 2, 30, "Input"],
Cell[6110, 147, 3822, 153, 61, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9969, 305, 164, 3, 30, "Input"],
Cell[10136, 310, 475, 11, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10660, 327, 196, 2, 43, "Subsection"],
Cell[CellGroupData[{
Cell[10881, 333, 286, 5, 30, "Input"],
Cell[11170, 340, 801, 15, 47, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12008, 360, 130, 2, 30, "Input"],
Cell[12141, 364, 2244, 38, 50, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14422, 407, 99, 2, 30, "Input"],
Cell[14524, 411, 448, 10, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15009, 426, 486, 10, 88, "Input"],
Cell[15498, 438, 2492, 56, 298, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18051, 501, 215, 3, 63, "Section"],
Cell[CellGroupData[{
Cell[18291, 508, 152, 2, 43, "Subsection"],
Cell[CellGroupData[{
Cell[18468, 514, 239, 4, 30, "Input"],
Cell[18710, 520, 827, 15, 47, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[19574, 540, 130, 2, 30, "Input"],
Cell[19707, 544, 4140, 165, 53, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23884, 714, 164, 3, 30, "Input"],
Cell[24051, 719, 1280, 41, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25368, 765, 216, 4, 30, "Input"],
Cell[25587, 771, 433, 8, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26069, 785, 215, 3, 43, "Subsection"],
Cell[CellGroupData[{
Cell[26309, 792, 470, 10, 88, "Input"],
Cell[26782, 804, 6578, 151, 490, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33421, 962, 254, 3, 63, "Section"],
Cell[CellGroupData[{
Cell[33700, 969, 152, 2, 43, "Subsection"],
Cell[CellGroupData[{
Cell[33877, 975, 254, 4, 30, "Input"],
Cell[34134, 981, 845, 15, 47, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[35016, 1001, 130, 2, 30, "Input"],
Cell[35149, 1005, 3864, 153, 61, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39050, 1163, 164, 3, 30, "Input"],
Cell[39217, 1168, 517, 11, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39771, 1184, 216, 4, 30, "Input"],
Cell[39990, 1190, 459, 9, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[40498, 1205, 215, 3, 43, "Subsection"],
Cell[CellGroupData[{
Cell[40738, 1212, 434, 9, 88, "Input"],
Cell[41175, 1223, 4916, 116, 499, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

